#include <stdio.h>
#include <math.h>

/* 
-------------------------------------------------------------------------------
Model presa-depredador (sense normalitzar). Inclou model discret i continu
-------------------------------------------------------------------------------
Dades: dt (duracio del pas de temps), imax (passos que es vol calcular), jmax
       (iteracions per resoldre les eqs. diferencials), nx0 (nombre inicial
       preses), ny0 (nombre inicial depredadors), a (parametre alfa), b
       (parametre beta), Rx (factor de creixement presa), delt (mortalitat
       depredador), Kx (capacitat presa)
Resultats: Fitxer "volterra.dat". Cada fila es un pas de temps. La primera 
           columna es el temps, la segona i la tercera son el nombre de preses
           i depredadors, respectivament, segons el model discret. La quarta
           i la cinquena son el mateix, pero amb el model continu.
Dades de prova: dt=0.1 imax=2 jmax=1 nx0=200 ny0=50 alfa=0.1 beta=0.1
                Rx=2.0 delt=0.1 Kx=1000 ==> 
                0.000000, 200.000003, 50.000001, 200.000003, 50.000001;
                0.100000, 310.403556, 45.050003, 359.499991, 45.049999;
                0.200000, 458.074749, 40.614922, 588.949978, 40.625975;
Observacions: Si compila malament, prova amb l'opcio -lm 
-------------------------------------------------------------------------------
*/

main()
{

int i,j,imax,jmax;
float dx,dy,dt,x0,y0,t0,x,y,t,xf,yf,tf,Xf,Yf,aa,bb,dd,
      xm,ym,tm,Kx,delt,Qx,Rx,rx,a,b,nx0,ny0,X,Y;
FILE *arxiu;

printf("Tamany del pas: ");
scanf("%f",&dt);
printf("Passos que vols calcular: ");
scanf("%d",&imax);
printf("Iteracions per estabilitzar (en dubte, posa 1): ");
scanf("%d",&jmax);
printf("Nombre inicial especie x: ");
scanf("%f",&nx0);
printf("Nombre inicial especie y: ");
scanf("%f",&ny0);
printf("Influencia especie y sobre x (alfa): ");
scanf("%f",&a);
printf("Influencia especie x sobre y (beta): ");
scanf("%f",&b);
printf("Factor de creixement especie x (Rx): ");
scanf("%f",&Rx);
printf("Mortalitat especie y (delta): ");
scanf("%f",&delt);
printf("Capacitat especie x: ");
scanf("%f",&Kx);

/* Hipotesi 1 */

rx=log(Rx)/dt;

/* Hipotesi 2 */

Qx=Kx*((1.0/(Rx-1))+1.0);
aa=a/dt*Kx/Qx;
bb=b;
dd=delt/dt;

/* Normalitzacio */

x0=nx0/Kx ;
y0=ny0/Kx ;
X=nx0/Qx ;
Y=ny0/Qx ;

arxiu=fopen("lotka2.dat","w");
t0=0;
x=x0;
y=y0;
t=t0;
xf=x0;
yf=y0;
fprintf(arxiu,"%f %f %f %f %f\n",t0,x0*Kx,y0*Kx,X*Qx,Y*Qx);
for(i=0;i<imax;i++)   
   {
   tm=t+dt/2.0;
   for(j=0;j<jmax;j++)
      {
      xm=(x+xf)/2.0;
      ym=(y+yf)/2.0;
      dx=dt*xm*(rx*(1.0-xm)-aa*ym);
      dy=dt*ym*(aa*bb*xm-dd);
      xf=x+dx;
      yf=y+dy;
      }
   x=xf;
   y=yf;
   t=t+dt;         
   Xf=Rx*(1.0-X)*X-a*X*Y;
   Yf=a*b*X*Y+(1.0-delt)*Y;
   X=Xf;
   Y=Yf;
   fprintf(arxiu,"%f %f %f %f %f\n",t,x*Kx,y*Kx,X*Qx,Y*Qx);
   }
fclose(arxiu);
}
